<!doctype html>
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
    <style>
        .layui-form-label{
            width:120px !important;
        }
        .layui-input-block{
            margin-left:120px !important;
        }
        .layui-form-text .layui-input-block{
            margin: 0 !important;
        }
        .layui-form-text .layui-form-label{
            width: 100% !important;
        }
    </style>
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-card">
        <div class="layui-card-header">
            <span class="layui-breadcrumb" lay-filter="breadcrumb" style="visibility: visible;">
              <a class="close" href="javascript:void(0);">上级列表</a><span lay-separator="">/</span>
              <a href="javascript:void(0);"><cite>编辑内容</cite></a>
            </span>
        </div>
        <div class="layui-card-body" style="padding: 15px;">
            <form class="layui-form layui-form-pane" lay-filter="dataForm">
                <div class="layui-form-item layui-form-text">
                    <label class="layui-form-label">机构图片</label>
                    <div class="layui-input-block">
                        <input type="hidden" id="institutionImage" name="institutionImage">
                        <div class="layui-btn-container" id="institutionImageFileBox" style="border: 1px solid #e6e6e6;"></div>
                        <script id="institutionImageFileDownload" type="text/html">
                            {{# var fileName = 'institutionImage'; }}
                            {{# if(d[fileName].length > 0) { }}
                            {{#    var files = d[fileName];}}
                            {{#    for(var i = 0, item = files[i]; item = files[i++];) { }}
                            <div class="upload-image-box">
                                <span class="upload-image-span">
                                    <img src="route/file/download/false/{{item.fileId}}" align="加载失败">
                                </span>
                                <a class="layui-btn layui-btn-xs layui-btn-danger text-danger remove-image" href="javascript:void(0);" lay-form-button data-id="{{item.fileId}}" data-name="{{fileName}}" lay-filter="institutionImageRemoveFile">
                                    <i class="fa fa-trash-o"></i>
                                </a>
                            </div>
                            {{#    } }}
                            {{# } }}
                            {{# if(d[fileName].length < 9) { }}
                            <div class="upload-image-box" style="width: auto; height: auto; padding: 5px;">
                                <a href="javascript:void(0);" lay-form-button data-explain="机构图片" data-name="institutionImage" lay-filter="institutionImageUploadFile">
                                    <i class="fa fa-plus-square-o" style="font-size: 70px;"></i>
                                </a>
                            </div>
                            {{# } }}
                        </script>
                    </div>
                </div>
                <div class="layui-form-item">
                    <label class="layui-form-label">机构名称</label>
                    <div class="layui-input-block">
                        <input type="text" id="institutionName" name="institutionName" class="layui-input" value="" placeholder="请输入机构名称"  maxlength="255" lay-verify="required">
                    </div>
                </div>
                <div class="layui-form-item">
                    <label class="layui-form-label">机构成立时间</label>
                    <div class="layui-input-block">
                        <input type="text" id="institutionFoundingTime" name="institutionFoundingTime" class="layui-input" value="" placeholder="请选择机构成立时间" readonly style="cursor: pointer;" lay-verify="required">
                    </div>
                </div>
                <div class="layui-form-item layui-form-text">
                    <label class="layui-form-label">机构描述</label>
                    <div class="layui-input-block">
                        <textarea id="institutionDesc" name="institutionDesc" class="layui-textarea" placeholder="请输入机构描述"></textarea>
                    </div>
                </div>
                <div class="layui-form-item">
                    <label class="layui-form-label">机构负责人</label>
                    <div class="layui-input-block">
                        <input type="text" id="institutionPrincipal" name="institutionPrincipal" class="layui-input" value="" placeholder="请输入机构负责人"  maxlength="100">
                    </div>
                </div>
                <div class="layui-form-item layui-form-text">
                    <label class="layui-form-label">机构联系方式</label>
                    <div class="layui-input-block">
                        <textarea id="institutionContact" name="institutionContact" class="layui-textarea" placeholder="请输入机构联系方式"></textarea>
                    </div>
                </div>
                <div class="layui-form-item">
                    <label class="layui-form-label">行政区划</label>
                    <div class="layui-input-inline">
                        <select name="institutionRegionProvince" id="institutionRegionProvince" lay-filter="institutionRegionProvince">
                            <option value="">请选择省</option>
                        </select>
                    </div>
                    <div class="layui-input-inline">
                        <select name="institutionRegionCity" id="institutionRegionCity" lay-filter="institutionRegionCity">
                            <option value="">请选择市</option>
                        </select>
                    </div>
                    <div class="layui-input-inline">
                        <select name="institutionRegionArea" id="institutionRegionArea" lay-filter="institutionRegionArea">
                            <option value="">请选择县</option>
                        </select>
                    </div>
                    <div class="layui-input-inline">
                        <select name="institutionRegionVillage" id="institutionRegionVillage" lay-filter="institutionRegionVillage">
                            <option value="">请选择镇</option>
                        </select>
                    </div>
                    <div class="layui-input-inline">
                        <select name="institutionRegionStreet" id="institutionRegionStreet" lay-filter="institutionRegionStreet">
                            <option value="">请选择村</option>
                        </select>
                    </div>
                </div>
                <div class="layui-form-item">
                    <label class="layui-form-label">机构详细地址</label>
                    <div class="layui-input-block">
                        <input type="hidden" id="institutionX" name="institutionX" value="" placeholder="请输入机构经度">
                        <input type="hidden" id="institutionY" name="institutionY" value="" placeholder="请输入机构纬度">
                        <input type="text" id="institutionAddress" name="institutionAddress" class="layui-input" value="" placeholder="请输入机构地址"  maxlength="50">
                    </div>
                </div>
                <div class="layui-row">
                    <div class="layui-col-md12 layui-col-sm12" style="padding: 0 0px;">
                        <div id="mapContainer" style="width: 100%;height: 350px;"></div>
                    </div>
                </div>
                <div class="layui-form-item layui-layout-admin">
                    <div class="layui-input-block">
                        <div class="layui-footer" style="left: 0;">
                            <button type="button" class="layui-btn" lay-submit lay-filter="submitForm">提交编辑</button>
                            <button type="button" class="layui-btn layui-btn-primary close">返回上级</button>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>
<script type="text/javascript" src="http://api.map.baidu.com/api?v=3.0&ak=oWU9RD4ihDHAafexgI6XOrTK8lDatRju"></script>
<script src="assets/js/vendor/wangEditor/wangEditor.min.js"></script>
<script src="assets/js/vendor/ckplayer/ckplayer/ckplayer.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/' //静态资源所在路径
    }).extend({
        index: 'lib/index' //主入口模块
    }).use(['index', 'form', 'laydate', 'laytpl'], function(){
        var $ = layui.$;
        var form = layui.form;
        var laytpl = layui.laytpl;
        var laydate = layui.laydate;
        var institutionId = top.restAjax.params(window.location.href).institutionId;
        var dictId = '0';

        var wangEditor = window.wangEditor;
        var wangEditorObj = {};
        var viewerObj = {};

        function closeBox() {
            parent.layer.close(parent.layer.getFrameIndex(window.name));
        }

        function refreshDownloadTemplet(fileName, file) {
            var dataRander = {};
            dataRander[fileName] = file;

            laytpl(document.getElementById(fileName +'FileDownload').innerHTML).render(dataRander, function(html) {
                document.getElementById(fileName +'FileBox').innerHTML = html;
            });
        }

        // 初始化文件列表
        function initFileList(fileName, ids, callback) {
            var dataForm = {};
            dataForm[fileName] = ids;
            form.val('dataForm', dataForm);

            if(!ids) {
                refreshDownloadTemplet(fileName, []);
                if(callback) {
                    callback(fileName, []);
                }
                return;
            }

            top.restAjax.get(top.restAjax.path('api/file/list', []), {
                ids: ids
            }, null, function(code, data) {
                refreshDownloadTemplet(fileName, data);
                if(callback) {
                    callback(fileName, data);
                }
            }, function(code, data) {
                top.dialog.msg(data.msg);
            });
        }

        // 初始化视频
        function initVideo(fileName, data) {
            for(var i = 0, item; item = data[i++];) {
                var player = new ckplayer({
                    container: '#'+ fileName + i,
                    variable: 'player',
                    flashplayer: false,
                    video: {
                        file: 'route/file/download/true/'+ item.fileId,
                        type: 'video/mp4'
                    }
                });
            }
        }

        // 初始化机构图片图片上传
        function initInstitutionImageUploadFile() {
            var files = $('#institutionImage').val();
            initFileList('institutionImage', files, function(fileName) {
                var viewer = new Viewer(document.getElementById(fileName +'FileBox'), {navbar: false});
                viewerObj[fileName] = viewer;
            });

            form.on('button(institutionImageUploadFile)', function(obj) {
                var name = this.dataset.name;
                var explain = this.dataset.explain;
                top.dialog.file({
                    type: 'image',
                    title: '上传'+ explain,
                    width: '400px',
                    height: '420px',
                    maxFileCount: '1',
                    onClose: function() {
                        var uploadFileArray = top.dialog.dialogData.uploadFileArray;
                        if(typeof(uploadFileArray) != 'undefined' && uploadFileArray.length > 0) {
                            var files = $('#'+ name).val();
                            for(var j = 0, file = uploadFileArray[j]; file = uploadFileArray[j++];) {
                                if(files.length > 0) {
                                    files += ',';
                                }
                                files += file.data;
                            }
                            initFileList(name, files, function(fileName) {
                                viewerObj[fileName].update();
                            });
                        }
                    }
                });
            });

            form.on('button(institutionImageRemoveFile)', function(obj) {
                var name = this.dataset.name;
                var id = this.dataset.id;
                var files = $('#'+ name).val().replace(id, '');
                files = files.replace(/\,+/g, ',');
                if(files.charAt(0) == ',') {
                    files = files.substring(1);
                }
                if(files.charAt(files.length - 1) == ',') {
                    files = files.substring(0, files.length - 1);
                }
                initFileList(name, files, function(fileName) {
                    viewerObj[fileName].update();
                });
            });
        }

        // 初始化机构成立时间时间戳
        function initInstitutionFoundingTimeDateTime(v) {
            laydate.render({
                elem: '#institutionFoundingTime',
                type: 'date',
                value: v,
                trigger: 'click'
            });
        }


        // 初始化内容
        function initData() {
            var loadLayerIndex;
            top.restAjax.get(top.restAjax.path('api/institution/get/{institutionId}', [institutionId]), {}, null, function(code, data) {
                var dataFormData = {};
                for(var i in data) {
                    dataFormData[i] = data[i] +'';
                }
                form.val('dataForm', dataFormData);
                form.render(null, 'dataForm');
                initInstitutionImageUploadFile();
                initInstitutionFoundingTimeDateTime(data.institutionFoundingTime);
                initMap(data.institutionX,data.institutionY);
                initDataDict(dictId,'institutionRegionProvince',data.institutionRegionProvince);
                initDataDict(data.institutionRegionProvince,'institutionRegionCity',data.institutionRegionCity);
                initDataDict(data.institutionRegionCity,'institutionRegionArea',data.institutionRegionArea);
                initDataDict(data.institutionRegionArea,'institutionRegionVillage',data.institutionRegionVillage);
                initDataDict(data.institutionRegionVillage,'institutionRegionStreet',data.institutionRegionStreet);
            }, function(code, data) {
                top.dialog.msg(data.msg);
            }, function() {
                loadLayerIndex = top.dialog.msg(top.dataMessage.loading, {icon: 16, time: 0, shade: 0.3});
            }, function() {
                top.dialog.close(loadLayerIndex);
            });
        }
        initData();
        
        // 提交表单
        form.on('submit(submitForm)', function(formData) {
            top.dialog.confirm(top.dataMessage.commit, function(index) {
                top.dialog.close(index);
                var loadLayerIndex;
                top.restAjax.put(top.restAjax.path('api/institution/update/{institutionId}', [institutionId]), formData.field, null, function(code, data) {
                    var layerIndex = top.dialog.msg(top.dataMessage.updateSuccess, {
                        time: 0,
                        btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                        shade: 0.3,
                        yes: function(index) {
                            top.dialog.close(index);
                            window.location.reload();
                        },
                        btn2: function() {
                            closeBox();
                        }
                    });
                }, function(code, data) {
                    top.dialog.msg(data.msg);
                }, function() {
                    loadLayerIndex = top.dialog.msg(top.dataMessage.committing, {icon: 16, time: 0, shade: 0.3});
                }, function() {
                    top.dialog.close(loadLayerIndex);
                });
            });
            return false;
        });

        $('.close').on('click', function() {
            closeBox();
        });


        //初始化百度地图
        function initMap(longitude, latitude) {
            if (longitude == '' || latitude == ''){
                longitude = '109.85017859252311';
                latitude = '40.66017700460503';
            }
            map = new BMap.Map("mapContainer", {enableMapClick: false,});
            var point = new BMap.Point(longitude, latitude);
            map.centerAndZoom(point, 13);
            map.disableDoubleClickZoom();
            map.addControl(new BMap.NavigationControl());
            map.addControl(new BMap.ScaleControl());
            map.addControl(new BMap.OverviewMapControl());
            map.addControl(new BMap.MapTypeControl());
            map.enableScrollWheelZoom();//启用地图滚轮放大缩小
            map.enableContinuousZoom();//开启缩放平滑
            // 点击获取地址
            var geocoder= new BMap.Geocoder();
            mapMarkPoint(map, point);
            map.addEventListener("click", function(e) {
                map.clearOverlays();
                $('#institutionX').val(e.point.lng);
                $('#institutionY').val(e.point.lat);
                point = new BMap.Point(e.point.lng, e.point.lat);
                mapMarkPoint(map, point);
                geocoder.getLocation(e.point, function(rs) {
                    $('#institutionAddress').val(rs.address);
                });
            });
        }
        //地图标点
        function mapMarkPoint(map, point) {
            var marker = new BMap.Marker(point);
            map.addOverlay(marker);
        }


        //c初始化数据字典
        function initDataDict(dictId,tabId,selectVelue){
            if(!dictId){
                return;
            }
            top.restAjax.get(top.restAjax.path("api/area/listbyparentid/{areaParentId}",[dictId]),{},null,function (code,data,args) {
                $("#"+tabId).empty();
                var html = '';
                if ('institutionRegionProvince' === tabId){
                    html += '<option value="">请选择省</option>';
                }
                if ('institutionRegionCity' === tabId){
                    html += '<option value="">请选择市</option>';
                }
                if ('institutionRegionArea' === tabId){
                    html += '<option value="">请选择县</option>';
                }
                if ('institutionRegionVillage' === tabId){
                    html += '<option value="">请选择镇</option>';
                }
                if ('institutionRegionStreet' === tabId){
                    html += '<option value="">请选择村</option>';
                }

                $.each(data, function (index, item) {
                    if(selectVelue ==  item.areaId){
                        html += '<option  selected value="'+item.areaId+'">'+item.areaName+'</option>';
                    }else{
                        html += '<option value="'+item.areaId+'">'+item.areaName+'</option>';
                    }
                });
                $("#"+tabId).append(html);
                form.render('select');
            });
        }

        //省监听事件
        form.on('select(institutionRegionProvince)', function(data){
            var v =  data.value;
            initDataDict(v,'institutionRegionCity');
        });
        //市监听事件
        form.on('select(institutionRegionCity)', function(data){
            var v =  data.value;
            initDataDict(v,'institutionRegionArea');
        });
        //区监听事件
        form.on('select(institutionRegionArea)', function(data){
            var v =  data.value;
            initDataDict(v,'institutionRegionVillage');
        });
        //镇、村监听事件
        form.on('select(institutionRegionVillage)', function(data){
            var v =  data.value;
            initDataDict(v,'institutionRegionStreet');
        });



        // 校验
        form.verify({
        });
    });
</script>
</body>
</html>